/// Problem  : G (School ACM 2006)
/// Solution : Igor V. Burago

#include <fstream>
#include <iomanip>
#include <sstream>
#include <string>
#include <algorithm>
using namespace std;

ifstream cin("input.txt");
ofstream cout("output.txt");

#define MAX_N 110
#define START_LINE_STR " starting line"

int n, m;
string name[MAX_N];
int place[MAX_N];
bool empty[MAX_N];
int col[MAX_N], width;
bool ocup[MAX_N][MAX_N];
string str;

string write(string str, int w)
{
  string result;
  int k = (w - str.length())/2;
  for (int i = 0; i < k; i++) result += ' ';
  result += str;
  for (int i = 0; i < w-k-str.length(); i++) result += ' ';
  return result;
}

int main()
{
  int i, j, k, l, man;

  cin >> n >> m >> ws;
  for (i = 0; i < n; i++) {
    getline(cin, name[i]);
    cin >> place[i] >> ws;
  }

  for (i = 0; i < n; i++) {
    empty[(place[i]-1) / m] = true;
    col[i] = (place[i]-1) % m;
    ocup[(place[i]-1) / m][col[i]] = true;
  }

  for (i = 0; i < n; i++)
    width = max(width, (int)(name[i].length() + 2));

  ostringstream tmp; tmp << (place[n-1]-1)/m << START_LINE_STR; str = tmp.str();
  while (str.length() + 2 > m*width + m-1) width++;

  man = 0;

  for (i = 0; i < m*width + m-1 + 2; i++) cout << '#';
  cout << endl;
  
  for (i = 0; i <= (place[n-1]-1)/m; i++) {
    if (!empty[i]) continue;
    
    ostringstream tmp; tmp << i+1 << START_LINE_STR; str = tmp.str();
    cout << '#' << write(str, m*width + m-1) << '#' << endl;

    cout << '#';
    for (j = 0; j < m; j++) {
      for (k = 0; k < width; k++) cout << '-';
      if (j < m-1) cout << '+';
    }
    cout << '#' << endl;

    for (j = 0; j < m; j++) {
      cout << '#';
      for (k = 0; k < m; k++) {
        if (j == k && ocup[i][k]) cout << write(name[man++], width);
        else for (l = 0; l < width; l++) cout << ' ';
        if (k < m-1) cout << '|';
      }
      cout << '#' << endl;
    }

    if (i < (place[n-1]-1)/m) {
      cout << '#';
      for (j = 0; j < m*width + m-1; j++) cout << '=';
      cout << '#' << endl;
    }
  }
  
  for (i = 0; i < m*width + m-1 + 2; i++) cout << '#';
  cout << endl;

  return 0;
}